//
// DirectSound class
//
#ifndef	__DIRECTSOUND_INCLUDED__
#define	__DIRECTSOUND_INCLUDED__

#define	WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#include <dsound.h>

#include "typedef.h"
#include "macro.h"

class	CDirectSound
{
public:
	// pubNoϐ
	typedef	struct	tagSAMPLERATE {
		DWORD	Rate;
		DWORD	Bits;
	} SAMPLERATE, *LPSAMPLERATE;

	SAMPLERATE		m_SampleRate;		// ݃TvO[g
	INT			m_BufferSize;		// obt@TCY(t[)
	static	SAMPLERATE	m_SampleRateTable[];	// TvO[ge[u
	static	INT		m_BufferSizeTable[];	// obt@TCYe[u

	// pubNo֐
	CDirectSound();
	virtual ~CDirectSound();

	BOOL	InitialDSound( HWND hWnd );
	void	ReleaseDSound();

	BOOL	InitialBuffer();
	void	ReleaseBuffer();

	BOOL	SetSamplingRate( DWORD rate, DWORD bits );
	void	GetSamplingRate( DWORD& rate, DWORD& bits );

	void	SetBufferSize( INT nSize ) { m_BufferSize = nSize; }
	INT	GetBufferSize()		   { return m_BufferSize; }

	BOOL	IsStreamPlaying() { return (m_bStreamPlay&&!m_bStreamPause); }
	void	StreamPlay();
	void	StreamStop();
	void	StreamPause();
	void	StreamResume();

	BOOL	GetStreamLockPosition( LPDWORD lpdwStart, LPDWORD lpdwSize );
	BOOL	StreamLock( DWORD dwWriteCursor, DWORD dwWriteBytes, LPVOID* lplpvPtr1, LPDWORD lpdwBytes1, LPVOID* lplpvPtr2, LPDWORD lpdwBytes2, DWORD dwFlags );
	BOOL	StreamUnlock( LPVOID lpvPtr1, DWORD dwBytes1, LPVOID lpvPtr2, DWORD dwBytes2 );

	BOOL	IsStreamPlay() { return m_bStreamPlay; }
	BOOL	IsStreamPause() { return m_bStreamPause; }

protected:
	// veNgoϐ
	HWND	m_hWnd;		// Window handle

	LPDIRECTSOUND		m_lpDS;		// DirectSoundIuWFNg
	LPDIRECTSOUNDBUFFER	m_lpDSPrimary;	// vC}IuWFNg

	LPDIRECTSOUNDBUFFER	m_lpDSStream;		// Xg[~OIuWFNg

	DWORD			m_dwDSBufferSize;
	DWORD			m_dwDSBlockSize;	// 1ubÑTCY
	DWORD			m_dwDSBlockNum;		// ubN̐
	DWORD			m_dwDSLastBlock;	// Ōɏ񂾃ubNʒu

	volatile BOOL		m_bStreamPlay;	// Xg[ĐtO
	volatile BOOL		m_bStreamPause;	// Xg[|[YtO

	// veNgo֐
private:
	// vCx[goϐ
	// vCx[go֐
};

extern	CDirectSound	DirectSound;

#endif	// !__DIRECTSOUND_INCLUDED__
