#ifndef	__STATE_INCLUDED__
#define	__STATE_INCLUDED__

#pragma pack( push, 1 )

typedef	struct	tagFILEHDR {	//  0123456789AB
	BYTE	ID[12];		// "VirtuaNES ST"
	WORD	Reserved;
	WORD	BlockVersion;
} FILEHDR, *LPFILEHDR;

// VirtuaNES version0.30ȍ~p
typedef	struct	tagFILEHDR2 {	//  0123456789AB
	BYTE	ID[12];		// "VirtuaNES ST"
	WORD	Reserved;
	WORD	BlockVersion;	// 0x0200

	DWORD	Ext0;		// ROM:vOCRC	FDS:vOID
	WORD	Ext1;		// ROM:Ȃ		FDS:[J[ID
	WORD	Ext2;		// ROM:Ȃ		FDS:fBXN
	LONG	MovieStep;	// ǋL(蒼)[r[̃t[
	LONG	MovieOffset;	// ǋL(蒼)[r[̃t@CItZbg
} FILEHDR2, *LPFILEHDR2;

typedef	struct	tagBLOCKHDR {
	BYTE	ID[8];
	WORD	Reserved;
	WORD	BlockVersion;
	DWORD	BlockSize;
} BLOCKHDR, *LPBLOCKHDR;

// CPU WX^
typedef	struct	tagCPUSTAT {
	WORD	PC;
	BYTE	A;
	BYTE	X;
	BYTE	Y;
	BYTE	S;
	BYTE	P;
	BYTE	I;	// Interrupt pending flag

	BYTE	FrameIRQ;
	BYTE	reserved[3];

	LONG	mod_cycles;	// [r[ŃNbN̔Ȃh
} CPUSTAT, *LPCPUSTAT;

// PPU WX^
typedef	struct	tagPPUSTAT {
	BYTE	reg0;
	BYTE	reg1;
	BYTE	reg2;
	BYTE	reg3;
	BYTE	reg7;
	BYTE	toggle56;

	WORD	loopy_t;
	WORD	loopy_v;
	WORD	loopy_x;
} PPUSTAT, *LPPPUSTAT;

// APU WX^(gTEh܂)
typedef	struct	tagAPUSTAT {
	BYTE	reg[0x0018];
	BYTE	ext[0x0100];
} APUSTAT, *LPAPUSTAT;

//
// WX^f[^
// ID "REG DATA"
typedef	struct	tagREGSTAT {
	union	CPUREG {
		BYTE	cpudata[32];
		CPUSTAT	cpu;
	} cpureg;
	union	PPUREG {
		BYTE	ppudata[32];
		PPUSTAT	ppu;
	} ppureg;
	APUSTAT	apu;
} REGSTAT, *LPREGSTAT;

//
// RAMf[^
// ID "RAM DATA"
typedef	struct	tagRAMSTAT {
	BYTE	RAM[2*1024];	// Internal NES RAM
	BYTE	BGPAL[16];	// BG Palette
	BYTE	SPPAL[16];	// SP Palette
	BYTE	SPRAM[256];	// Sprite RAM
} RAMSTAT, *LPRAMSTAT;

//
// MMUf[^
// ID "MMU DATA"
typedef	struct	tagMMUSTAT {
	BYTE	CPU_MEM_TYPE[8];
	WORD	CPU_MEM_PAGE[8];
	BYTE	PPU_MEM_TYPE[12];
	WORD	PPU_MEM_PAGE[12];
	BYTE	CRAM_USED[8];
} MMUSTAT, *LPMMUSTAT;

//
// }bp[f[^
// ID "MMC DATA"
typedef	struct	tagMMCSTAT {
	BYTE	mmcdata[256];
} MMCSTAT, *LPMMCSTAT;

//
// Rg[f[^
// ID "CONTDATA"
typedef	struct	tagCONTSTAT {
	BYTE	type1;
	BYTE	type2;
	BYTE	shift1;
	BYTE	shift2;
	DWORD	data1;
	DWORD	data2;
} CONTSTAT, *LPCONTSTAT;

//
// fBXNC[W
// Ver0.24܂
// ID "DSIDE 0A","DSIDE 0B","DSIDE 1A","DSIDE 1B"
typedef	struct	tagDISKSTAT {
	BYTE	DiskTouch[16];
} DISKSTAT, *LPDISKSTAT;

// Ver0.30ȍ~
// ID "DISKDATA"
typedef	struct	tagDISKDATA {
	LONG	DifferentSize;
} DISKDATA, *LPDISKDATA;

// ȉ̓fBXNZ[uC[Wt@CŎgp
// Ver0.24܂
typedef	struct	tagDISKIMGFILEHDR {	//  0123456789AB
	BYTE	ID[12];		// "VirtuaNES DI"
	WORD	BlockVersion;
	WORD	DiskNumber;
} DISKIMGFILEHDR, *LPDISKIMGFILEHDR;

typedef	struct	tagDISKIMGHDR {
	BYTE	ID[6];		// ID "SIDE0A","SIDE0B","SIDE1A","SIDE1B"
	BYTE	DiskTouch[16];
} DISKIMGHDR, *LPDISKIMGHDR;

// VirtuaNES version0.30ȍ~p
typedef	struct	tagDISKFILEHDR {	//  0123456789AB
	BYTE	ID[12];		// "VirtuaNES DI"
	WORD	BlockVersion;	// 0x0200:0.30	0x0210:0.31
	WORD	Reserved;
	DWORD	ProgID;		// vOID
	WORD	MakerID;	// [J[ID
	WORD	DiskNo;		// fBXN
	DWORD	DifferentSize;	// ᐔ
} DISKFILEHDR, *LPDISKFILEHDR;


//
// [r[t@C
//
typedef	struct	tagMOVIEIMGFILEHDR {
	BYTE	ID[12];			// "VirtuaNES MV"
	WORD	BlockVersion;
	WORD	reserved;
	LONG	StateStOffset;		// Movie start state offset
	LONG	StateEdOffset;		// Movie end state offset
	LONG	MovieOffset;		// Movie data offset
	LONG	MovieStep;		// Movie steps
} MOVIEIMGFILEHDR, *LPMOVIEIMGFILEHDR;

// VirtuaNES version0.30ȍ~p
typedef	struct	tagMOVIEFILEHDR {
	BYTE	ID[12];			// "VirtuaNES MV"
	WORD	BlockVersion;		// 0x0200
	WORD	reserved;
	DWORD	Control;		// Rg[oCg
					// 76543210(Bit)
					// E---4321
					// |   |||+-- 1Pf[^
					// |   ||+--- 2Pf[^
					// |   |+---- 3Pf[^
					// |   +----- 4Pf[^
					// +--------- ǋL֎~
					// ̑Rg[1P`4P(ǂłǂ)̕L[
					// SON̎ĈSoCgRg[pf[^ɂȂ
	DWORD	Ext0;			// ROM:vOCRC	FDS:vOID
	WORD	Ext1;			// ROM:Ȃ		FDS:[J[ID
	WORD	Ext2;			// ROM:Ȃ		FDS:fBXN
	DWORD	RecordTimes;		// L^(蒼)

	LONG	StateStOffset;		// Movie start state offset
	LONG	StateEdOffset;		// Movie end state offset
	LONG	MovieOffset;		// Movie data offset
	LONG	MovieStep;		// Movie steps(Frame)

	DWORD	CRC;			// ̃f[^CRC(C`Lh~)
} MOVIEFILEHDR, *LPMOVIEFILEHDR;

// Famtasia Movie....
typedef	struct	tagFMVHDR {
	BYTE	ID[4];			// "FMV^Z"
	BYTE	Control1;		// R???????	0:ZbgォL^H 1:rL^
	BYTE	Control2;		// OT??????	O:1P T:2P
	DWORD	Unknown1;
	WORD	RecordTimes;		// L^-1
	DWORD	Unknown2;
	BYTE	szEmulators[0x40];	// L^G~[^
	BYTE	szTitle    [0x40];	// ^Cg
} FMVHDR, *LPFMVHDR;

// Nesticle Movie....
typedef	struct	tagNMVHDR {
	BYTE	ExRAM[0x2000];
	BYTE	S_RAM[0x0800];
	WORD	PC;
	BYTE	A;
	BYTE	P;
	BYTE	X;
	BYTE	Y;
	BYTE	SP;
	BYTE	OAM[0x0100];
	BYTE	VRAM[0x4000];
	BYTE	Other[0xC9];
	DWORD	ScanlineCycles;
	DWORD	VblankScanlines;
	DWORD	FrameScanlines;
	DWORD	VirtualFPS;
} NMVHDR, *LPNMVHDR;

#pragma pack( pop )

#endif	// !__STATE_INCLUDED__
