//
// lbgvCNX
//
// IWinSock LibN
#pragma comment(lib, "wsock32.lib")

#include "DebugOut.h"

#include "NetPlay.h"

#define	CLOSESOCKET(soc) if((soc)!=INVALID_SOCKET){::closesocket((soc));(soc)=INVALID_SOCKET;}

CNetPlay	NetPlay;

CNetPlay::CNetPlay()
{
	m_hWnd = m_hWndMsg = NULL;
	m_bConnect = FALSE;

	m_SocketConnect = INVALID_SOCKET;
	m_SocketData = INVALID_SOCKET;
}

CNetPlay::~CNetPlay()
{
	// Ƃ肠
	Release();
}

BOOL	CNetPlay::Initialize( HWND hWnd )
{
	// Ƃ肠
	Release();

	// WinSock DLL̏
	if( ::WSAStartup( MAKEWORD(1,1), &m_WSAdata ) )
		return	FALSE;

	// o[WႤ`
	if( m_WSAdata.wVersion != MAKEWORD(1,1) ) {
		::WSACleanup();
		return	FALSE;
	}

	m_hWnd = hWnd;
	return	TRUE;
}

void	CNetPlay::Release()
{
	Disconnect();

	if( m_hWnd ) {
		::WSACleanup();
		m_hWnd = NULL;
	}
}

BOOL	CNetPlay::Connect( BOOL bServer, const char* IP, unsigned short Port )
{
	if( !m_hWnd )
		return	FALSE;

	m_bServer = bServer;

	if( bServer ) {
	// Server
		// ڑʒm\Pbg쐬
		if( m_SocketConnect == INVALID_SOCKET ) {
			m_SocketConnect = ::socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
			if( m_SocketConnect == INVALID_SOCKET ) {
				DEBUGOUT( "CNetPlay:socket failed.\n" );
				return	FALSE;
			}
		}
		// |[gƌт
		struct sockaddr_in addr;
		::ZeroMemory( &addr, sizeof(addr) );
		addr.sin_family      = AF_INET;
		addr.sin_addr.s_addr = ::htonl( INADDR_ANY );
		addr.sin_port        = ::htons( Port );
		if( ::bind( m_SocketConnect, (struct sockaddr *)&addr, sizeof(addr) ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:bind failed.\n" );
			CLOSESOCKET( m_SocketConnect );
			return	FALSE;
		}
		// ڑvCxg̐ݒ
		if( ::WSAAsyncSelect( m_SocketConnect, m_hWnd, WM_NETPLAY, FD_ACCEPT ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:WSAAsyncSelect failed.\n" );
			CLOSESOCKET( m_SocketConnect );
			return	FALSE;
		}
		// ڑvtJn
		if( ::listen( m_SocketConnect, 1 ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:listen failed.\n" );
			CLOSESOCKET( m_SocketConnect );
			return	FALSE;
		}
	} else {
	// Client
		// IPAhXH
		unsigned long IP_address = ::inet_addr( IP );
		if( IP_address == INADDR_NONE ) {
			DEBUGOUT( "CNetPlay:IPAhXsłB\"%s\"\n", IP );
			return	FALSE;
		}

		// f[^ʐM\Pbg쐬
		m_SocketData = ::socket( AF_INET, SOCK_STREAM, IPPROTO_TCP );
		if( m_SocketData == INVALID_SOCKET ) {
			DEBUGOUT( "CNetPlay:socket failed.\n" );
			return	FALSE;
		}
		// NagleASY̖
		BOOL	bOpt = TRUE;
		if( ::setsockopt( m_SocketData, IPPROTO_TCP, TCP_NODELAY, (const char*)&bOpt, sizeof(bOpt) ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:setsockopt failed.\n" );
			CLOSESOCKET( m_SocketData );
			return	FALSE;
		}
		// ubLO[hݒ
		BOOL	bArg = TRUE;
		if( ::ioctlsocket( m_SocketData, FIONBIO, (unsigned long*)&bArg ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:ioctlsocket failed.\n" );
			CLOSESOCKET( m_SocketData );
			return	FALSE;
		}
		// ڑCxg̐ݒ
		if( ::WSAAsyncSelect( m_SocketData, m_hWnd, WM_NETPLAY, FD_CONNECT ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:WSAAsyncSelect failed.\n" );
			CLOSESOCKET( m_SocketData );
			return	FALSE;
		}
		// ڑv
		struct sockaddr_in addr;
		::ZeroMemory( &addr, sizeof(addr) );
		addr.sin_family      = AF_INET;
		addr.sin_addr.s_addr = IP_address;
		addr.sin_port        = ::htons( Port );
		if( ::connect( m_SocketData, (struct sockaddr *)&addr, sizeof(addr) ) == SOCKET_ERROR ) {
			if( ::WSAGetLastError() != WSAEWOULDBLOCK ) {
				DEBUGOUT( "CNetPlay:connect failed.\n" );
				CLOSESOCKET( m_SocketData );
				return	FALSE;
			}
		}
	}

	return	TRUE;
}

void	CNetPlay::Disconnect()
{
	// \PbgVbg_EĔj
	if( m_SocketConnect != INVALID_SOCKET ) {
//		::shutdown( m_SocketConnect, SD_BOTH );	// WS2ȍ~炵c
		CLOSESOCKET( m_SocketConnect );
	}
	if( m_SocketData != INVALID_SOCKET ) {
//		::shutdown( m_SocketData, SD_BOTH );	// WS2ȍ~炵c
		CLOSESOCKET( m_SocketData );
	}

	m_bConnect = FALSE;
}

INT	CNetPlay::Send( unsigned char* pBuf, int size )
{
	if( !m_hWnd || !m_bConnect || m_SocketData == INVALID_SOCKET )
		return	-1L;

	if( ::send( m_SocketData, (char*)pBuf, size, 0 ) == SOCKET_ERROR ) {
		DEBUGOUT( "CNetPlay:send failed. code=%d\n", ::WSAGetLastError() );
		Disconnect();
		return	-1L;
	}

	return	0L;
}

INT	CNetPlay::Recv( unsigned char* pBuf, int size )
{
	if( !m_hWnd || !m_bConnect || m_SocketData == INVALID_SOCKET )
		return	-1L;

	// f[^͂Ă邩mF
	unsigned long	len = 0;
	if( ::ioctlsocket( m_SocketData, FIONREAD, (unsigned long*)&len ) == SOCKET_ERROR ) {
		DEBUGOUT( "CNetPlay:ioctlsocket failed.\n" );
		Disconnect();
		return	-1L;
	}

	if( !len ) {
		// f[^͂ĂȂ
		return	0L;
	} else {
		// vf[^TCYǂݍ
		if( ::recv( m_SocketData, (char*)pBuf, size, 0 ) == SOCKET_ERROR ) {
			DEBUGOUT( "CNetPlay:recv failed.\n" );
			Disconnect();
			return	-1L;
		}
	}

	return	size;
}

INT	CNetPlay::RecvTime( unsigned char* pBuf, int size, unsigned long timeout )
{
	INT	ret;
	unsigned long dwTimeOut;
	dwTimeOut = ::timeGetTime();
	while( (ret = NetPlay.Recv( pBuf, size )) == 0 ) {
		// ł܂Ȃ[u
		::Sleep( 0 );
		// ^CAEg̃`FbN
		if( (::timeGetTime()-dwTimeOut) > timeout ) {
			return	-1;
		}
	}
	return	ret;
}

HRESULT	CNetPlay::WndProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	// G[H
	if( WSAGETSELECTERROR(lParam) ) {
#if	0
		switch( WSAGETSELECTERROR(lParam) ) {
			case	WSAEINTR:
				MessageBox( hWnd, "֐ĂяofꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAEBADF:
				MessageBox( hWnd, "ȃt@CnhB\n", "ERROR", MB_OK );
				break;
			case	WSAEACCES:
				MessageBox( hWnd, "ANZXۂꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAEFAULT:
				MessageBox( hWnd, "ȃobt@AhXłB\n", "ERROR", MB_OK );
				break;
			case	WSAEINVAL:
				MessageBox( hWnd, "ȈnꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAEMFILE:
				MessageBox( hWnd, "gp̃\Pbg̐B\n", "ERROR", MB_OK );
				break;
			case	WSAEWOULDBLOCK:
				MessageBox( hWnd, "̓ubLOB\n", "ERROR", MB_OK );
				break;
			case	WSAEINPROGRESS:
				MessageBox( hWnd, "ɃubLO葱sĂB\n", "ERROR", MB_OK );
				break;
			case	WSAEALREADY:
				MessageBox( hWnd, "vꂽ͊ɎsA܂͎sς݁B\n", "ERROR", MB_OK );
				break;
			case	WSAENOTSOCK:
				MessageBox( hWnd, "w肳ꂽ\PbgłB\n", "ERROR", MB_OK );
				break;
//			case	WSAEDESTADDREQ:
//				MessageBox( hWnd, "̎sɑMAhXKvB\n", "ERROR", MB_OK );
//				break;
			case	WSAEMSGSIZE:
				MessageBox( hWnd, "bZ[WTCY傫B\n", "ERROR", MB_OK );
				break;
			case	WSAEPROTOTYPE:
				MessageBox( hWnd, "\Pbg͗vꂽvgRɓKĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAENOPROTOOPT:
				MessageBox( hWnd, "sȃvgRIvVB\n", "ERROR", MB_OK );
				break;
			case	WSAEPROTONOSUPPORT:
				MessageBox( hWnd, "vgRT|[gĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAESOCKTNOSUPPORT:
				MessageBox( hWnd, "w肳ꂽ\Pbg^Cv̓T|[gĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAEOPNOTSUPP:
				MessageBox( hWnd, "vꂽ̓T|[gĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAEPFNOSUPPORT:
				MessageBox( hWnd, "vgRt@~T|[gĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAEAFNOSUPPORT:
				MessageBox( hWnd, "AhXt@~T|[gĂȂB\n", "ERROR", MB_OK );
				break;

			case	WSAEADDRINUSE:
				MessageBox( hWnd, "AhX͊ɎgpłB\n", "ERROR", MB_OK );
				break;
			case	WSAEADDRNOTAVAIL:
				MessageBox( hWnd, "ȃlbg[NAhXB\n", "ERROR", MB_OK );
				break;
			case	WSAENETDOWN:
				MessageBox( hWnd, "lbg[N_EĂB\n", "ERROR", MB_OK );
				break;
			case	WSAENETUNREACH:
				MessageBox( hWnd, "w肳ꂽlbg[NzXgɓBłȂB\n", "ERROR", MB_OK );
				break;
			case	WSAENETRESET:
				MessageBox( hWnd, "lbg[NڑjꂽB\n", "ERROR", MB_OK );
				break;

			case	WSAECONNRESET:
				MessageBox( hWnd, "lbg[NڑɂĔjꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAENOBUFS:
				MessageBox( hWnd, "obt@sĂB\n", "ERROR", MB_OK );
				break;
			case	WSAEISCONN:
				MessageBox( hWnd, "\Pbg͊ɐڑĂB\n", "ERROR", MB_OK );
				break;
			case	WSAENOTCONN:
				MessageBox( hWnd, "\Pbg͐ڑĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAESHUTDOWN:
				MessageBox( hWnd, "\Pbg̓Vbg_EĂB\n", "ERROR", MB_OK );
				break;
			case	WSAETOOMANYREFS:
				MessageBox( hWnd, "QƂ̐B\n", "ERROR", MB_OK );
				break;

			case	WSAETIMEDOUT:
				MessageBox( hWnd, "ڑv^CAEgB\n", "ERROR", MB_OK );
				break;
			case	WSAECONNREFUSED:
				MessageBox( hWnd, "ڑۂꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAELOOP:
				MessageBox( hWnd, "[vB\n", "ERROR", MB_OK );
				break;
			case	WSAENAMETOOLONG:
				MessageBox( hWnd, "OB\n", "ERROR", MB_OK );
				break;
			case	WSAEHOSTDOWN:
				MessageBox( hWnd, "zXg_EĂB\n", "ERROR", MB_OK );
				break;
			case	WSAEHOSTUNREACH:
				MessageBox( hWnd, "zXgւ̌oHȂB\n", "ERROR", MB_OK );
				break;
			case	WSAENOTEMPTY:
				MessageBox( hWnd, "fBNgł͂ȂB\n", "ERROR", MB_OK );
				break;
			case	WSAEPROCLIM:
				MessageBox( hWnd, "[U[̐B\n", "ERROR", MB_OK );
				break;
			case	WSAEDQUOT:
				MessageBox( hWnd, "fBXNNH[^B\n", "ERROR", MB_OK );
				break;
			case	WSAESTALE:
				MessageBox( hWnd, "s悤Ƃ͔p~ĂB\n", "ERROR", MB_OK );
				break;


			case	WSAEREMOTE:
				MessageBox( hWnd, "[gB\n", "ERROR", MB_OK );
				break;
			case	WSASYSNOTREADY:
				MessageBox( hWnd, "lbg[NTuVXepłȂB\n", "ERROR", MB_OK );
				break;
			case	WSAVERNOTSUPPORTED:
				MessageBox( hWnd, "Winsock.dll̃o[W͈͊OłB\n", "ERROR", MB_OK );
				break;
			case	WSANOTINITIALISED:
				MessageBox( hWnd, "WinSockVXeĂȂB\n", "ERROR", MB_OK );
				break;
			case	WSAEDISCON:
				MessageBox( hWnd, "Vbg_EB\n", "ERROR", MB_OK );
				break;
			case	WSAENOMORE:
				MessageBox( hWnd, "f[^͂ȏ㑶݂ȂB\n", "ERROR", MB_OK );
				break;
			case	WSAECANCELLED:
				MessageBox( hWnd, "͎ꂽB\n", "ERROR", MB_OK );
				break;

			case	WSAEINVALIDPROCTABLE:
				MessageBox( hWnd, "T[rXvoC_̊֐e[uB\n", "ERROR", MB_OK );
				break;
			case	WSAEINVALIDPROVIDER:
				MessageBox( hWnd, "T[rXvoC_B\n", "ERROR", MB_OK );
				break;
			case	WSAEPROVIDERFAILEDINIT:
				MessageBox( hWnd, "T[rXvoC_̏ɎsB\n", "ERROR", MB_OK );
				break;
			case	WSASYSCALLFAILURE:
				MessageBox( hWnd, "VXeR[ɎsB\n", "ERROR", MB_OK );
				break;
			case	WSASERVICE_NOT_FOUND:
				MessageBox( hWnd, "T[rXȂB\n", "ERROR", MB_OK );
				break;
			case	WSATYPE_NOT_FOUND:
				MessageBox( hWnd, "^CvȂB\n", "ERROR", MB_OK );
				break;
			case	WSA_E_NO_MORE:
				MessageBox( hWnd, "f[^͂ȏ㑶݂ȂB\n", "ERROR", MB_OK );
				break;
			case	WSA_E_CANCELLED:
				MessageBox( hWnd, "LZꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAEREFUSED:
				MessageBox( hWnd, "͋ۂꂽB\n", "ERROR", MB_OK );
				break;
			case	WSAHOST_NOT_FOUND:
				MessageBox( hWnd, "zXgȂB\n", "ERROR", MB_OK );
				break;
			case	WSATRY_AGAIN:
				MessageBox( hWnd, "w肳ꂽzXgȂA܂̓T[rẌُB\n", "ERROR", MB_OK );
				break;
			case	WSANO_RECOVERY:
				MessageBox( hWnd, "񕜕s\ȃG[B\n", "ERROR", MB_OK );
				break;
			case	WSANO_DATA:
				MessageBox( hWnd, "vꂽ^Cṽf[^R[hȂB\n", "ERROR", MB_OK );
				break;

		}
#endif
		Disconnect();
		if( m_hWndMsg ) {
			::PostMessage( m_hWndMsg, WM_NETPLAY_CLOSE, 0, 0 );
		}
		return	0L;
	}

	BOOL	bOpt;
	BOOL	bArg;

	switch( WSAGETSELECTEVENT(lParam) ) {
		case	FD_ACCEPT:
			DEBUGOUT( "Accepting...." );
			sockaddr_in	addr;
			int	len;
			len = sizeof(addr);
			m_SocketData = ::accept( m_SocketConnect, (sockaddr*)&addr, &len );
			if( m_SocketData == INVALID_SOCKET ) {
				DEBUGOUT( "failed.\n" );
				CLOSESOCKET( m_SocketConnect );
				if( m_hWndMsg ) {
					::PostMessage( m_hWndMsg, WM_NETPLAY_ERROR, 0, 0 );
				}
				return	0L;
			}
			DEBUGOUT( "done.\n" );

			// NagleASY̖
			bOpt = TRUE;
			if( ::setsockopt( m_SocketData, IPPROTO_TCP, TCP_NODELAY, (const char*)&bOpt, sizeof(bOpt) ) == SOCKET_ERROR ) {
				DEBUGOUT( "CNetPlay:setsockopt failed.\n" );
				CLOSESOCKET( m_SocketData );
				if( m_hWndMsg ) {
					::PostMessage( m_hWndMsg, WM_NETPLAY_ERROR, 0, 0 );
				}
				return	0L;
			}
			// ubLO[hݒ
			bArg = TRUE;
			if( ::ioctlsocket( m_SocketData, FIONBIO, (unsigned long*)&bArg ) == SOCKET_ERROR ) {
				DEBUGOUT( "CNetPlay:ioctlsocket failed.\n" );
				CLOSESOCKET( m_SocketData );
				if( m_hWndMsg ) {
					::PostMessage( m_hWndMsg, WM_NETPLAY_ERROR, 0, 0 );
				}
				return	0L;
			}
			::WSAAsyncSelect( m_SocketData, m_hWnd, WM_NETPLAY, FD_CLOSE );
			m_bConnect = TRUE;
			if( m_hWndMsg ) {
				::PostMessage( m_hWndMsg, WM_NETPLAY_ACCEPT, 0, 0 );
			}
			break;
		case	FD_CONNECT:
			DEBUGOUT( "Connection done.\n" );
			::WSAAsyncSelect( m_SocketData, m_hWnd, WM_NETPLAY, FD_CLOSE );
			m_bConnect = TRUE;
			if( m_hWndMsg ) {
				::PostMessage( m_hWndMsg, WM_NETPLAY_CONNECT, 0, 0 );
			}
			break;
		case	FD_CLOSE:
			DEBUGOUT( "Connection close.\n" );
			Disconnect();
			if( m_hWndMsg ) {
				::PostMessage( m_hWndMsg, WM_NETPLAY_CLOSE, 0, 0 );
			}
			break;
	}

	return	0L;
}

